import pandas as pd
import os
import sys
import re
import os.path
import argparse

def my_console_script():
    ap = argparse.ArgumentParser()
    ap.add_argument("-i", "--InputDirectory", required=True,help="path to input directory")
    ap.add_argument("-o", "--OutPutFileName", required=True,help="OutputFilename/Path to OutputFile")
    args = vars(ap.parse_args())


# DirectoryContainingDAAFileInfo= sys.argv[1]
# PathToOutputFileWithName= sys.argv[2]
    DirectoryContainingDAAFileInfo= args['InputDirectory']
    PathToOutputFileWithName=  args['OutPutFileName']

    def FormatFileName(DirectoryPath):
        FileName = [] 
        for r,d,f in os.walk(DirectoryPath):
            for file in f:
                FileName.append(DirectoryPath+file)
        return(FileName)


    def MakeTable(ReceiveFileNameString,ReceivePathToOutputFileWithName):
        firstDataframeFileName=ReceiveFileNameString[0]
        ReceiveFileNameString.pop(0)
        XnumberOfDataframestring=firstDataframeFileName.split("/")[-1]
        # filename=XnumberOfDataframestring[1].split("_")[0]
        filename=XnumberOfDataframestring.split("_")[0]
        colname=['TAXA',filename]
        dataframereadFirst=pd.read_csv(firstDataframeFileName,sep='\t',names = colname,encoding="utf-8-sig",dtype=str)
        for XnumberOfDataframe in ReceiveFileNameString:
            XnumberOfDataframestring=XnumberOfDataframe.split("/")[-1]
            # filename=XnumberOfDataframestring[1].split("_")[0]
            filename=XnumberOfDataframestring.split("_")[0]
            colname=['TAXA',filename]
            dataframereadIterating=pd.read_csv(XnumberOfDataframe,sep='\t',names = colname,encoding="utf-8-sig",dtype=str)
            dataframereadFirst=pd.merge(dataframereadFirst, dataframereadIterating, on='TAXA', how='outer')
            dataframereadFirst=dataframereadFirst.fillna(0)
            #print(dataframereadFirst)
        dataframereadFirst.to_csv(ReceivePathToOutputFileWithName,sep="\t", index = False, header=True)

    FileNameString=FormatFileName(DirectoryContainingDAAFileInfo)
    #print(FileNameString)
    MakeTable(FileNameString,PathToOutputFileWithName)
